## mingw-w64-inkscape-1.3.2-6.src.tar.zst

=== share/symbols/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
file(GLOB _FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.svg" "sjjb/*.svg")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/symbols.h
  COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/i18n.py ${_FILES} > ${CMAKE_CURRENT_BINARY_DIR}/symbols.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/i18n.py ${_FILES}
)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/symbols.h PROPERTIES GENERATED TRUE)
add_custom_target(symbols_h ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/symbols.h)

install(FILES ${_FILES} "README" DESTINATION ${INKSCAPE_SHARE_INSTALL}/symbols)

=== share/tutorials/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later

file(GLOB _FILES "README" "*.svg" "*.jpg" "*.png")

filter_and_install_translated_content(_FILES ${INKSCAPE_SHARE_INSTALL}/tutorials)
if(WIN32)
install(FILES ${_FILES}
    DESTINATION ${INKSCAPE_SHARE_INSTALL}/tutorials
    COMPONENT tutorials)
else()
install(FILES ${_FILES}
    DESTINATION ${INKSCAPE_SHARE_INSTALL}/tutorials
    COMPONENT inkscape)
endif()

=== src/async/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later

set(async_SRC
	async.cpp

	async.h
	channel.h
	background-progress.h
	progress.h
	progress-splitter.h
)

add_inkscape_source("${async_SRC}")

=== src/display/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later

set(display_SRC
    cairo-utils.cpp
    curve.cpp
    drawing-context.cpp
    drawing-group.cpp
    drawing-image.cpp
    drawing-item.cpp
    drawing-paintserver.cpp
    drawing-pattern.cpp
    drawing-shape.cpp
    drawing-surface.cpp
    drawing-text.cpp
    drawing.cpp
    nr-3dutils.cpp
    nr-filter-blend.cpp
    nr-filter-colormatrix.cpp
    nr-filter-component-transfer.cpp
    nr-filter-composite.cpp
    nr-filter-convolve-matrix.cpp
    nr-filter-diffuselighting.cpp
    nr-filter-displacement-map.cpp
    nr-filter-flood.cpp
    nr-filter-gaussian.cpp
    nr-filter-image.cpp
    nr-filter-merge.cpp
    nr-filter-morphology.cpp
    nr-filter-offset.cpp
    nr-filter-primitive.cpp
    # nr-filter-skeleton.cpp
    nr-filter-slot.cpp
    nr-filter-specularlighting.cpp
    nr-filter-tile.cpp
    nr-filter-turbulence.cpp
    nr-filter-units.cpp
    nr-filter.cpp
    nr-light.cpp
    nr-style.cpp
    nr-svgfonts.cpp

    control/canvas-temporary-item-list.cpp
    control/canvas-temporary-item.cpp
    control/snap-indicator.cpp

    control/canvas-item.cpp
    control/canvas-item-bpath.cpp
    control/canvas-item-catchall.cpp
    control/canvas-item-context.cpp
    control/canvas-item-ctrl.cpp
    control/canvas-item-curve.cpp
    control/canvas-item-drawing.cpp
    control/canvas-item-grid.cpp
    control/canvas-item-group.cpp
    control/canvas-item-guideline.cpp
    control/canvas-item-quad.cpp
    control/canvas-item-rect.cpp
    control/canvas-item-text.cpp
    control/canvas-page.cpp

    # -------
    # Headers
    cairo-templates.h
    cairo-utils.h
    curve.h
    drawing-context.h
    drawing-group.h
    drawing-image.h
    drawing-item.h
    drawing-item-ptr.h
    drawing-paintserver.h
    drawing-pattern.h
    drawing-shape.h
    drawing-surface.h
    drawing-text.h
    drawing.h
    initlock.h
    nr-3dutils.h
    nr-filter-blend.h
    nr-filter-colormatrix.h
    nr-filter-component-transfer.h
    nr-filter-composite.h
    nr-filter-convolve-matrix.h
    nr-filter-diffuselighting.h
    nr-filter-displacement-map.h
    nr-filter-flood.h
    nr-filter-gaussian.h
    nr-filter-image.h
    nr-filter-merge.h
    nr-filter-morphology.h
    nr-filter-offset.h
    nr-filter-primitive.h
    nr-filter-skeleton.h
    nr-filter-slot.h
    nr-filter-specularlighting.h
    nr-filter-tile.h
    nr-filter-turbulence.h
    nr-filter-types.h
    nr-filter-units.h
    nr-filter-utils.h
    nr-filter.h
    nr-light-types.h
    nr-light.h
    nr-style.h
    nr-svgfonts.h
    rendermode.h
    tags.h

    control/canvas-temporary-item-list.h
    control/canvas-temporary-item.h
    control/snap-indicator.h

    control/canvas-item.h
    control/canvas-item-bpath.h
    control/canvas-item-buffer.h
    control/canvas-item-catchall.h
    control/canvas-item-context.h
    control/canvas-item-ctrl.h
    control/canvas-item-curve.h
    control/canvas-item-drawing.h
    control/canvas-item-enums.h
    control/canvas-item-grid.h
    control/canvas-item-group.h
    control/canvas-item-guideline.h
    control/canvas-item-ptr.h
    control/canvas-item-quad.h
    control/canvas-item-rect.h
    control/canvas-item-text.h
    control/canvas-page.h
)

# add_inkscape_lib(display_LIB "${display_SRC}")
add_inkscape_source("${display_SRC}")

=== src/extension/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later

set(extension_SRC
	db.cpp
	dependency.cpp
	effect.cpp
	execution-env.cpp
	extension.cpp
	init.cpp
	input.cpp
	output.cpp
	patheffect.cpp
	print.cpp
	system.cpp
	template.cpp
	timer.cpp
    loader.cpp

	implementation/implementation.cpp
	implementation/xslt.cpp
	implementation/script.cpp

	internal/bluredge.cpp
	internal/cairo-ps-out.cpp
	internal/cairo-render-context.cpp
	internal/cairo-renderer.cpp
	internal/cairo-renderer-pdf-out.cpp
	internal/emf-inout.cpp
	internal/emf-print.cpp
	internal/gdkpixbuf-input.cpp
	internal/gimpgrad.cpp
	internal/grid.cpp
	internal/image-resolution.cpp
	internal/latex-pstricks.cpp
	internal/latex-pstricks-out.cpp
	internal/metafile-inout.cpp
	internal/metafile-print.cpp
	internal/odf.cpp
	internal/latex-text-renderer.cpp
	internal/png-output.cpp
	internal/pov-out.cpp
	internal/svg.cpp
	internal/svgz.cpp
	internal/template-base.cpp
	internal/template-from-file.cpp
	internal/template-other.cpp
	internal/template-paper.cpp
	internal/template-screen.cpp
	internal/template-social.cpp
	internal/template-video.cpp
	internal/text_reassemble.c
	internal/wmf-inout.cpp
	internal/wmf-print.cpp

	internal/filter/filter-all.cpp
	internal/filter/filter-file.cpp
	internal/filter/filter.cpp

	prefdialog/prefdialog.cpp
	prefdialog/parameter.cpp
	prefdialog/parameter-bool.cpp
	prefdialog/parameter-color.cpp
	prefdialog/parameter-float.cpp
	prefdialog/parameter-int.cpp
	prefdialog/parameter-notebook.cpp
	prefdialog/parameter-optiongroup.cpp
	prefdialog/parameter-path.cpp
	prefdialog/parameter-string.cpp
	prefdialog/widget.cpp
	prefdialog/widget-box.cpp
	prefdialog/widget-image.cpp
	prefdialog/widget-label.cpp
	prefdialog/widget-separator.cpp
	prefdialog/widget-spacer.cpp

	# ------
	# Header
	db.h
	dependency.h
	effect.h
	execution-env.h
	extension.h
	init.h
	input.h
	output.h
	patheffect.h
	print.h
	system.h
	template.h
	timer.h
    loader.h

	implementation/implementation.h
	implementation/script.h
	implementation/xslt.h

	internal/bluredge.h
	internal/cairo-ps-out.h
	internal/cairo-render-context.h
	internal/cairo-renderer-pdf-out.h
	internal/cairo-renderer.h
	internal/clear-n_.h
	internal/emf-inout.h
	internal/emf-print.h
	internal/filter/bevels.h
	internal/filter/blurs.h
	internal/filter/bumps.h
	internal/filter/color.h
	internal/filter/distort.h
	internal/filter/filter.h
	internal/filter/image.h
	internal/filter/morphology.h
	internal/filter/overlays.h
	internal/filter/paint.h
	internal/filter/protrusions.h
	internal/filter/shadows.h
	internal/filter/textures.h
	internal/filter/transparency.h
	internal/gdkpixbuf-input.h
	internal/gimpgrad.h
	internal/grid.h
	internal/image-resolution.h
	internal/latex-pstricks-out.h
	internal/latex-pstricks.h
	internal/latex-text-renderer.h
	internal/metafile-inout.h
	internal/metafile-print.h
	internal/odf.h
	internal/pdfinput/enums.h
	internal/png-output.h
	internal/pov-out.h
	internal/svg.h
	internal/svgz.h
	internal/template-base.h
	internal/template-from-file.h
	internal/template-other.h
	internal/template-paper.h
	internal/template-screen.h
	internal/template-social.h
	internal/template-video.h
	internal/text_reassemble.h
	internal/wmf-inout.h
	internal/wmf-print.h

	prefdialog/prefdialog.h
	prefdialog/parameter.h
	prefdialog/parameter-bool.h
	prefdialog/parameter-color.h
	prefdialog/parameter-float.h
	prefdialog/parameter-int.h
	prefdialog/parameter-notebook.h
	prefdialog/parameter-optiongroup.h
	prefdialog/parameter-path.h
	prefdialog/parameter-string.h
	prefdialog/widget.h
	prefdialog/widget-box.h
	prefdialog/widget-image.h
	prefdialog/widget-label.h
	prefdialog/widget-separator.h
	prefdialog/widget-spacer.h
)

if(WIN32)
	list(APPEND extension_SRC
	)
endif()

if(ENABLE_POPPLER)
    list(APPEND extension_SRC
        internal/pdfinput/pdf-utils.cpp
        internal/pdfinput/pdf-input.cpp
        internal/pdfinput/pdf-parser.cpp
        internal/pdfinput/svg-builder.cpp
        internal/pdfinput/poppler-utils.cpp
        internal/pdfinput/poppler-cairo-font-engine.cpp

        # Header
        internal/pdfinput/pdf-utils.h
        internal/pdfinput/pdf-input.h
        internal/pdfinput/pdf-parser.h
        internal/pdfinput/svg-builder.h
        internal/pdfinput/poppler-utils.h
        internal/pdfinput/poppler-cairo-font-engine.h
    )
endif()

if(WITH_LIBCDR)
	list(APPEND extension_SRC
		internal/cdr-input.cpp
		internal/cdr-input.h
	)
endif()

if(WITH_LIBVISIO)
	list(APPEND extension_SRC
		internal/vsd-input.cpp
		internal/vsd-input.h
	)
endif()

if(WITH_LIBWPG)
	list(APPEND extension_SRC
		internal/wpg-input.cpp
		internal/wpg-input.h
	)
endif()

if(WITH_MAGICK)
	list(APPEND extension_SRC
		internal/bitmap/adaptiveThreshold.cpp
		internal/bitmap/adaptiveThreshold.h
		internal/bitmap/addNoise.cpp
		internal/bitmap/addNoise.h
		internal/bitmap/blur.cpp
		internal/bitmap/blur.h
		internal/bitmap/channel.cpp
		internal/bitmap/channel.h
		internal/bitmap/charcoal.cpp
		internal/bitmap/charcoal.h
		internal/bitmap/colorize.cpp
		internal/bitmap/colorize.h
		internal/bitmap/contrast.cpp
		internal/bitmap/contrast.h
		internal/bitmap/crop.cpp
		internal/bitmap/crop.h
		internal/bitmap/cycleColormap.cpp
		internal/bitmap/cycleColormap.h
		internal/bitmap/despeckle.cpp
		internal/bitmap/despeckle.h
		internal/bitmap/edge.cpp
		internal/bitmap/edge.h
		internal/bitmap/emboss.cpp
		internal/bitmap/emboss.h
		internal/bitmap/enhance.cpp
		internal/bitmap/enhance.h
		internal/bitmap/equalize.cpp
		internal/bitmap/equalize.h
		internal/bitmap/gaussianBlur.cpp
		internal/bitmap/gaussianBlur.h
		internal/bitmap/imagemagick.cpp
		internal/bitmap/imagemagick.h
		internal/bitmap/implode.cpp
		internal/bitmap/implode.h
		internal/bitmap/level.cpp
		internal/bitmap/level.h
		internal/bitmap/levelChannel.cpp
		internal/bitmap/levelChannel.h
		internal/bitmap/medianFilter.cpp
		internal/bitmap/medianFilter.h
		internal/bitmap/modulate.cpp
		internal/bitmap/modulate.h
		internal/bitmap/negate.cpp
		internal/bitmap/negate.h
		internal/bitmap/normalize.cpp
		internal/bitmap/normalize.h
		internal/bitmap/oilPaint.cpp
		internal/bitmap/oilPaint.h
		internal/bitmap/opacity.cpp
		internal/bitmap/opacity.h
		internal/bitmap/raise.cpp
		internal/bitmap/raise.h
		internal/bitmap/reduceNoise.cpp
		internal/bitmap/reduceNoise.h
		internal/bitmap/sample.cpp
		internal/bitmap/sample.h
		internal/bitmap/shade.cpp
		internal/bitmap/shade.h
		internal/bitmap/sharpen.cpp
		internal/bitmap/sharpen.h
		internal/bitmap/solarize.cpp
		internal/bitmap/solarize.h
		internal/bitmap/spread.cpp
		internal/bitmap/spread.h
		internal/bitmap/swirl.cpp
		internal/bitmap/swirl.h
		internal/bitmap/threshold.cpp
		internal/bitmap/threshold.h
		internal/bitmap/unsharpmask.cpp
		internal/bitmap/unsharpmask.h
		internal/bitmap/wave.cpp
		internal/bitmap/wave.h
	)
endif()

# add_inkscape_lib(extension_LIB "${extension_SRC}")
add_inkscape_source("${extension_SRC}")

add_subdirectory( plugins )

=== src/ui/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
set(ui_SRC
	builder-utils.cpp
	clipboard.cpp
	contextmenu.cpp
	cursor-utils.cpp
	dialog-events.cpp
	draw-anchor.cpp
	drag-and-drop.cpp
	icon-loader.cpp
	interface.cpp
	monitor.cpp
	selected-color.cpp
	shape-editor.cpp
	shape-editor-knotholders.cpp
	simple-pref-pusher.cpp
	shortcuts.cpp
	svg-renderer.cpp
	syntax.cpp
	themes.cpp
	tool-factory.cpp
	util.cpp
	modifiers.cpp

	cache/svg_preview_cache.cpp

	desktop/document-check.cpp
	desktop/menubar.cpp
	desktop/menu-icon-shift.cpp

	knot/knot.cpp
	knot/knot-holder.cpp
	knot/knot-holder-entity.cpp
	knot/knot-ptr.cpp

	tool/control-point-selection.cpp
	tool/control-point.cpp
	tool/curve-drag-point.cpp
	tool/event-utils.cpp
	tool/modifier-tracker.cpp
	tool/multi-path-manipulator.cpp
	tool/node.cpp
	tool/path-manipulator.cpp
	tool/selectable-control-point.cpp
	tool/transform-handle-set.cpp

	toolbar/arc-toolbar.cpp
	toolbar/box3d-toolbar.cpp
	toolbar/calligraphy-toolbar.cpp
	toolbar/connector-toolbar.cpp
	toolbar/dropper-toolbar.cpp
	toolbar/marker-toolbar.cpp
	toolbar/eraser-toolbar.cpp
	toolbar/gradient-toolbar.cpp
	toolbar/lpe-toolbar.cpp
	toolbar/measure-toolbar.cpp
	toolbar/mesh-toolbar.cpp
	toolbar/node-toolbar.cpp
	toolbar/page-toolbar.cpp
	toolbar/paintbucket-toolbar.cpp
	toolbar/pencil-toolbar.cpp
	toolbar/rect-toolbar.cpp
	toolbar/select-toolbar.cpp
	toolbar/booleans-toolbar.cpp
	toolbar/spiral-toolbar.cpp
	toolbar/spray-toolbar.cpp
	toolbar/star-toolbar.cpp
	toolbar/text-toolbar.cpp
	toolbar/toolbar.cpp
	toolbar/tweak-toolbar.cpp
	toolbar/zoom-toolbar.cpp

	tools/arc-tool.cpp
	tools/box3d-tool.cpp
	tools/calligraphic-tool.cpp
	tools/connector-tool.cpp
	tools/dropper-tool.cpp
	tools/dynamic-base.cpp
	tools/eraser-tool.cpp
	tools/flood-tool.cpp
	tools/freehand-base.cpp
	tools/gradient-tool.cpp
	tools/lpe-tool.cpp
	tools/measure-tool.cpp
	tools/mesh-tool.cpp
	tools/node-tool.cpp
	tools/pages-tool.cpp
	tools/pencil-tool.cpp
	tools/pen-tool.cpp
	tools/rect-tool.cpp
	tools/marker-tool.cpp
	tools/select-tool.cpp
	tools/booleans-builder.cpp
	tools/booleans-tool.cpp
	tools/booleans-subitems.cpp
	tools/spiral-tool.cpp
	tools/spray-tool.cpp
	tools/star-tool.cpp
	tools/text-tool.cpp
	tools/tool-base.cpp
	tools/tweak-tool.cpp
	tools/zoom-tool.cpp

	dialog/about.cpp
	dialog/align-and-distribute.cpp
	dialog/calligraphic-profile-rename.cpp
	dialog/clonetiler.cpp
	dialog/color-item.cpp
	dialog/command-palette.cpp
	dialog/attrdialog.cpp
	dialog/debug.cpp
	dialog/dialog-base.cpp
	dialog/dialog-container.cpp
	dialog/dialog-data.cpp
	dialog/dialog-manager.cpp
	dialog/dialog-multipaned.cpp
	dialog/dialog-notebook.cpp
	dialog/dialog-window.cpp
	dialog/document-properties.cpp
	dialog/document-resources.cpp
	dialog/export.cpp
	dialog/export-batch.cpp
	dialog/export-single.cpp
	dialog/filedialog.cpp
	dialog/filedialogimpl-gtkmm.cpp
	dialog/fill-and-stroke.cpp
	dialog/filter-effects-dialog.cpp
	dialog/find.cpp
	dialog/font-collections-manager.cpp
	widget/font-collection-selector.cpp
	dialog/font-substitution.cpp
	dialog/global-palettes.cpp
	dialog/glyphs.cpp
	dialog/grid-arrange-tab.cpp
	dialog/guides.cpp
	dialog/icon-preview.cpp
	dialog/inkscape-preferences.cpp
	dialog/input.cpp
	dialog/knot-properties.cpp
	dialog/layer-properties.cpp
	dialog/livepatheffect-add.cpp
	dialog/livepatheffect-editor.cpp
	dialog/lpe-fillet-chamfer-properties.cpp
	dialog/lpe-powerstroke-properties.cpp
	dialog/memory.cpp
	dialog/messages.cpp
	dialog/new-from-template.cpp
	dialog/object-attributes.cpp
	dialog/object-properties.cpp
	dialog/objects.cpp
	dialog/polar-arrange-tab.cpp
	dialog/print.cpp
	dialog/prototype.cpp
	dialog/selectorsdialog.cpp
	dialog/startup.cpp
	dialog/styledialog.cpp
	dialog/svg-fonts-dialog.cpp
	dialog/svg-preview.cpp
	dialog/swatches.cpp
	dialog/symbols.cpp
	dialog/paint-servers.cpp
	dialog/text-edit.cpp
	dialog/tile.cpp
	dialog/tracedialog.cpp
	dialog/transformation.cpp
	dialog/undo-history.cpp
	dialog/xml-tree.cpp
	dialog/save-template-dialog.cpp

	widget/iconrenderer.cpp
	widget/alignment-selector.cpp
	widget/anchor-selector.cpp
	widget/completion-popup.cpp
	widget/canvas.cpp
	widget/canvas/stores.cpp
	widget/canvas/synchronizer.cpp
	widget/canvas/util.cpp
	widget/canvas/texture.cpp
	widget/canvas/texturecache.cpp
	widget/canvas/pixelstreamer.cpp
	widget/canvas/updaters.cpp
	widget/canvas/framecheck.cpp
	widget/canvas/glgraphics.cpp
	widget/canvas/cairographics.cpp
	widget/canvas/graphics.cpp
	widget/canvas-grid.cpp
	widget/canvas-notice.cpp
	widget/color-entry.cpp
	widget/color-icc-selector.cpp
	widget/color-notebook.cpp
	widget/color-palette.cpp
	widget/color-picker.cpp
	widget/color-preview.cpp
	icon-loader.cpp
	widget/color-scales.cpp
	widget/color-slider.cpp
	widget/combo-box-entry-tool-item.cpp
	widget/combo-tool-item.cpp
	widget/custom-tooltip.cpp
	widget/dash-selector.cpp
	widget/entity-entry.cpp
	widget/entry.cpp
	widget/export-lists.cpp
	widget/export-preview.cpp
	widget/filter-effect-chooser.cpp
	widget/fill-style.cpp
	widget/font-button.cpp
	widget/font-selector.cpp
	widget/font-selector-toolbar.cpp
	widget/font-variants.cpp
	widget/font-variations.cpp
	widget/frame.cpp
	widget/gradient-image.cpp
	widget/gradient-editor.cpp
	widget/gradient-selector.cpp
	widget/gradient-vector-selector.cpp
	widget/gradient-with-stops.cpp
	widget/image-properties.cpp
	widget/imagetoggler.cpp
	widget/ink-color-wheel.cpp
	widget/ink-ruler.cpp
	widget/ink-spinscale.cpp
	widget/label-tool-item.cpp
	widget/labelled.cpp
	widget/layer-selector.cpp
	widget/licensor.cpp
	widget/marker-combo-box.cpp
	widget/notebook-page.cpp
	widget/object-composite-settings.cpp
	widget/objects-dialog-cells.cpp
	widget/oklab-color-wheel.cpp
	widget/optglarea.cpp
	widget/page-properties.cpp
	widget/page-size-preview.cpp
	widget/page-selector.cpp
	widget/paint-selector.cpp
	widget/pattern-editor.cpp
	widget/point.cpp
	widget/preferences-widget.cpp
	widget/random.cpp
	widget/registered-widget.cpp
	widget/registry.cpp
	widget/rendering-options.cpp
	widget/rotateable.cpp
	widget/scalar-unit.cpp
	widget/scalar.cpp
	widget/scroll-utils.cpp
	widget/selected-style.cpp
	widget/shapeicon.cpp
	widget/spin-button-tool-item.cpp
	widget/spin-scale.cpp
	widget/spinbutton.cpp
	widget/stroke-style.cpp
	widget/style-subject.cpp
	widget/style-swatch.cpp
	widget/swatch-selector.cpp
	widget/template-list.cpp
	widget/text.cpp
	widget/tolerance-slider.cpp
	widget/unit-menu.cpp
	widget/unit-tracker.cpp

	view/svg-view-widget.cpp
	view/view.cpp
	view/view-widget.cpp


	# -------
	# Headers
	builder-utils.h
	clipboard.h
	contextmenu.h
	cursor-utils.h
	control-types.h
	dialog-events.h
	drag-and-drop.h
	draw-anchor.h
	event-debug.h
	filtered-store.h
	icon-names.h
	icon-loader.h
	interface.h
	monitor.h
	selected-color.h
	shape-editor.h
	simple-pref-pusher.h
	shortcuts.h
	syntax.h
	themes.h
	tool-factory.h
	util.h
	modifiers.h

	cache/svg_preview_cache.h

	desktop/document-check.h
	desktop/menubar.h
	desktop/menu-icon-shift.h

	dialog/about.h
	dialog/align-and-distribute.h
	dialog/arrange-tab.h
	dialog/calligraphic-profile-rename.h
	dialog/clonetiler.h
	dialog/color-item.h
	dialog/command-palette.h
	dialog/attrdialog.h
	dialog/debug.h
	dialog/dialog-base.h
	dialog/dialog-container.h
	dialog/dialog-data.h
	dialog/dialog-manager.h
	dialog/dialog-multipaned.h
	dialog/dialog-notebook.h
	dialog/dialog-window.h
	dialog/document-properties.h
	dialog/export.h
	dialog/export-batch.h
	dialog/export-single.h
	dialog/filedialog.h
	dialog/filedialogimpl-gtkmm.h
	dialog/filedialogimpl-win32.h
	dialog/fill-and-stroke.h
	dialog/filter-effects-dialog.h
	dialog/find.h
	dialog/font-collections-manager.h
	dialog/font-substitution.h
	dialog/global-palettes.h
	dialog/glyphs.h
	dialog/grid-arrange-tab.h
	dialog/guides.h
	dialog/icon-preview.h
	dialog/inkscape-preferences.h
	dialog/input.h
	dialog/knot-properties.h
	dialog/layer-properties.h
	dialog/livepatheffect-add.h
	dialog/livepatheffect-editor.h
	dialog/lpe-fillet-chamfer-properties.h
	dialog/lpe-powerstroke-properties.h
	dialog/memory.h
	dialog/messages.h
	dialog/new-from-template.h
	dialog/object-attributes.h
	dialog/object-properties.h
	dialog/objects.h
	dialog/polar-arrange-tab.h
	dialog/print.h
	dialog/prototype.h
	dialog/selectorsdialog.h
	dialog/startup.h
	dialog/styledialog.h
	dialog/svg-fonts-dialog.h
	dialog/svg-preview.h
	dialog/swatches.h
	dialog/symbols.h
	dialog/paint-servers.h
	dialog/text-edit.h
	dialog/tile.h
	dialog/tracedialog.h
	dialog/transformation.h
	dialog/undo-history.h
	dialog/xml-tree.h
	dialog/save-template-dialog.h

	knot/knot.h
	knot/knot-enums.h
	knot/knot-holder.h
	knot/knot-holder-entity.h
	knot/knot-ptr.h

	tool/commit-events.h
	tool/control-point-selection.h
	tool/control-point.h
	tool/curve-drag-point.h
	tool/event-utils.h
	tool/manipulator.h
	tool/modifier-tracker.h
	tool/multi-path-manipulator.h
	tool/node-types.h
	tool/node.h
	tool/path-manipulator.h
	tool/selectable-control-point.h
	tool/shape-record.h
	tool/transform-handle-set.h

	toolbar/arc-toolbar.h
	toolbar/box3d-toolbar.h
	toolbar/calligraphy-toolbar.h
	toolbar/connector-toolbar.h
	toolbar/dropper-toolbar.h
	toolbar/marker-toolbar.h
	toolbar/eraser-toolbar.h
	toolbar/gradient-toolbar.h
	toolbar/lpe-toolbar.h
	toolbar/measure-toolbar.h
	toolbar/mesh-toolbar.h
	toolbar/node-toolbar.h
	toolbar/page-toolbar.h
	toolbar/paintbucket-toolbar.h
	toolbar/pencil-toolbar.h
	toolbar/rect-toolbar.h
	toolbar/select-toolbar.h
	toolbar/booleans-toolbar.h
	toolbar/spiral-toolbar.h
	toolbar/spray-toolbar.h
	toolbar/star-toolbar.h
	toolbar/text-toolbar.h
	toolbar/toolbar.h
	toolbar/tweak-toolbar.h
	toolbar/zoom-toolbar.h

	tools/arc-tool.h
	tools/box3d-tool.h
	tools/calligraphic-tool.h
	tools/connector-tool.h
	tools/dropper-tool.h
	tools/dynamic-base.h
	tools/eraser-tool.h
	tools/flood-tool.h
	tools/freehand-base.h
	tools/gradient-tool.h
	tools/lpe-tool.h
	tools/measure-tool.h
	tools/mesh-tool.h
	tools/node-tool.h
	tools/pages-tool.h
	tools/pen-tool.h
	tools/pencil-tool.h
	tools/rect-tool.h
	tools/marker-tool.h
	tools/select-tool.h
	tools/booleans-builder.h
	tools/booleans-tool.h
	tools/booleans-subitems.h
	tools/spiral-tool.h
	tools/spray-tool.h
	tools/star-tool.h
	tools/text-tool.h
	tools/tool-base.h
	tools/tweak-tool.h
	tools/zoom-tool.h

	widget/iconrenderer.h
	widget/alignment-selector.h
	widget/anchor-selector.h
	widget/attr-widget.h
	widget/canvas.h
	widget/canvas/fragment.h
	widget/canvas/prefs.h
	widget/canvas/stores.h
	widget/canvas/synchronizer.h
	widget/canvas/util.h
	widget/canvas/texture.h
	widget/canvas/texturecache.h
	widget/canvas/graphics.h
	widget/canvas/pixelstreamer.h
	widget/canvas/updaters.h
	widget/canvas/framecheck.h
	widget/canvas/glgraphics.h
	widget/canvas/cairographics.h
	widget/canvas-grid.h
        widget/canvas-notice.h
	widget/completion-popup.h
	widget/color-entry.h
	widget/color-icc-selector.h
	widget/color-notebook.h
	widget/color-palette.h
	widget/color-picker.h
	widget/color-preview.h
	widget/color-scales.h
	widget/color-slider.h
	widget/combo-enums.h
	widget/combo-box-entry-tool-item.h
	widget/combo-tool-item.h
	widget/custom-tooltip.h
	widget/dash-selector.h
	widget/entity-entry.h
	widget/entry.h
	widget/export-lists.h
	widget/export-preview.h
	widget/fill-style.h
	widget/filter-effect-chooser.h
	widget/font-button.h
	widget/font-collection-selector.h
	widget/font-selector.h
	widget/font-selector-toolbar.h
	widget/font-variants.h
	widget/font-variations.h
	widget/frame.h
	widget/gradient-image.h
	widget/gradient-editor.h
	widget/gradient-selector.h
	widget/gradient-vector-selector.h
	widget/gradient-with-stops.h
	widget/image-properties.h
	widget/imagetoggler.h
	widget/ink-color-wheel.h
	widget/ink-ruler.h
	widget/ink-spinscale.h
	widget/label-tool-item.h
	widget/labelled.h
	widget/layer-selector.h
	widget/licensor.h
	widget/marker-combo-box.h
	widget/notebook-page.h
	widget/object-composite-settings.h
	widget/objects-dialog-cells.h
	widget/oklab-color-wheel.h
	widget/optglarea.h
	widget/page-selector.h

=== src/util/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later

set(util_SRC
	action-accel.cpp
    document-fonts.cpp
	expression-evaluator.cpp
	format_size.cpp
	funclog.cpp
	pool.cpp
    font-collections.cpp
	share.cpp
    object-renderer.cpp
	paper.cpp
	preview.cpp
	statics.cpp
    recently-used-fonts.cpp
	units.cpp
	xim_fix.cpp
	ziptool.cpp


	# -------
	# Headers
	action-accel.h
	cached_map.h
	cast.h
	const_char_ptr.h
    document-fonts.h
	enums.h
	expression-evaluator.h
    font-collections.h
	fixed_point.h
	format.h
	format_size.h
	forward-pointer-iterator.h
	funclog.h
	longest-common-suffix.h
    object-renderer.h
	optstr.h
	pages-skeleton.h
	paper.h
	parse-int-range.h
	pool.h
	preview.h
    recently-used-fonts.h
	reference.h
	scope_exit.h
	share.h
	signal-blocker.h
	statics.h
	trim.h
	units.h
	xim_fix.h
	ziptool.h
	numeric/converters.h
)

add_inkscape_lib(util_LIB "${util_SRC}")
target_link_libraries(util_LIB PUBLIC 2Geom::2geom)
# add_inkscape_source("${util_SRC}")

=== testfiles/cli_tests/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later


# Helper function to add a CLI test
#
# Run an Inkscape command line and check for pass/fail condition (by default only exit status is checked)
#
# Command line options:
#   INPUT_FILENAME     - name of input file (optional)
#   OUTPUT_FILENAME    - name of output file (optional)
#   OUTPUT_PAGE        - index of page in multipage output (optional), starts from 0
#   FUZZ_PERCENTAGE    - maximum allowed normalized root-mean-squared distance between compared images
#   RASTER_DPI         - DPI setting for rasterizing vector formats before root-mean-squared comparison
#   PARAMETERS         - additional command line parameters to pass to Inkscape
#
# Pass/fail criteria:
#   PASS_FOR_OUTPUT    - pass if output matches the given value, otherwise fail
#                        see https://cmake.org/cmake/help/latest/prop_test/PASS_REGULAR_EXPRESSION.html for details
#   FAIL_FOR_OUTPUT    - fail if output matches the given value
#                        see https://cmake.org/cmake/help/latest/prop_test/FAIL_REGULAR_EXPRESSION.html for details
#   REFERENCE_FILENAME - compare OUTPUT_FILENAME with this pre-rendered reference file
#                        both files are converted to PNG and compared with ImageMagick's 'compare'
#                        for multipage output, use OUTPUT_PAGE to specify a single page for comparison
#   FUZZYREF_FILENAME  - comparison of OUTPUT_FILENAME with this pre-rendered reference file will be
#                        performed in the L2 metric, subject to the specified FUZZ_PERCENTAGE
#   EXPECTED_FILES     - verify the command produced the expected files (i.e. they exist on disk)
#   TEST_SCRIPT        - additional script to run after performing all checks and before cleaning up
#
# Other options:
#   ENVIRONMENT        - Additional environment variables to set while running the test
function(add_cli_test name)
    # parse arguments
    set(oneValueArgs INPUT_FILENAME OUTPUT_FILENAME OUTPUT_PAGE PASS_FOR_OUTPUT FAIL_FOR_OUTPUT REFERENCE_FILENAME
        FUZZYREF_FILENAME FUZZ_PERCENTAGE RASTER_DPI)
    set(multiValueArgs PARAMETERS EXPECTED_FILES TEST_SCRIPT ENVIRONMENT)
    cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    set(testname  cli_${name})

    #disable dithering
    set(ARG_PARAMETERS ${ARG_PARAMETERS}  "--export-png-use-dithering=false")

    if(DEFINED ARG_OUTPUT_FILENAME)
        # for actions: if an export-do is present do not append export-filename option to prevent
        if(NOT ARG_PARAMETERS MATCHES "export-do")
            set(ARG_PARAMETERS ${ARG_PARAMETERS} "--export-filename=${ARG_OUTPUT_FILENAME}")
        endif()
    endif()
    if(DEFINED ARG_INPUT_FILENAME)
        set(ARG_INPUT_FILENAME "${CMAKE_CURRENT_SOURCE_DIR}/testcases/${ARG_INPUT_FILENAME}")
        set(ARG_PARAMETERS ${ARG_PARAMETERS} ${ARG_INPUT_FILENAME})
    endif()

    set(CMAKE_CTEST_ENV "${INKSCAPE_TEST_PROFILE_DIR_ENV}/${testname};${CMAKE_CTEST_ENV}")
    if(DEFINED ARG_ENVIRONMENT)
        if(ARG_ENVIRONMENT STREQUAL "unset")
            unset(CMAKE_CTEST_ENV)
        else()
            # variables might already be set, however the last value wins
            list(APPEND CMAKE_CTEST_ENV ${ARG_ENVIRONMENT})
        endif()
    endif()

    # add test for main command line
    add_test(NAME ${testname} COMMAND inkscape ${ARG_PARAMETERS})
    set_tests_properties(${testname} PROPERTIES ENVIRONMENT "${CMAKE_CTEST_ENV}")
    if(DEFINED ARG_PASS_FOR_OUTPUT)
        set_tests_properties(${testname} PROPERTIES PASS_REGULAR_EXPRESSION ${ARG_PASS_FOR_OUTPUT})
    endif()
    if(DEFINED ARG_FAIL_FOR_OUTPUT)
        set_tests_properties(${testname} PROPERTIES FAIL_REGULAR_EXPRESSION ${ARG_FAIL_FOR_OUTPUT})
    endif()

    # add test to check output files
    if(DEFINED ARG_REFERENCE_FILENAME OR DEFINED ARG_EXPECTED_FILES OR DEFINED ARG_TEST_SCRIPT)
        if(DEFINED ARG_REFERENCE_FILENAME)
            file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/testcases/${ARG_REFERENCE_FILENAME}" ARG_REFERENCE_FILENAME)
        endif()
        if(DEFINED ARG_EXPECTED_FILES)
            string(REPLACE ";" " " ARG_EXPECTED_FILES "${ARG_EXPECTED_FILES}")
        endif()
        if(DEFINED ARG_TEST_SCRIPT)
            set(ARG_TEST_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/${ARG_TEST_SCRIPT}")
        endif()

        add_test(NAME ${testname}_check_output
            COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/check_output.sh
                    "${ARG_OUTPUT_FILENAME}" "${ARG_OUTPUT_PAGE}" "${ARG_REFERENCE_FILENAME}"
                    "${ARG_EXPECTED_FILES}" "${ARG_TEST_SCRIPT}")
        set_tests_properties(${testname}_check_output PROPERTIES
            ENVIRONMENT "${CMAKE_CTEST_ENV}" DEPENDS ${testname} SKIP_RETURN_CODE 42)
    endif()

    # add a fuzzy test to check the output files
    if(DEFINED ARG_FUZZYREF_FILENAME)
        file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/testcases/${ARG_FUZZYREF_FILENAME}" ARG_FUZZYREF_FILENAME)
        if(DEFINED ARG_FUZZ_PERCENTAGE)
            set(ARG_FUZZ "${ARG_FUZZ_PERCENTAGE}")
        else()
            set(ARG_FUZZ "0")
        endif()
        add_test(NAME ${testname}_check_output
            COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/l2compare.sh
            "${ARG_OUTPUT_FILENAME}" "${ARG_OUTPUT_PAGE}" "${ARG_FUZZYREF_FILENAME}" "${ARG_FUZZ}" "${ARG_RASTER_DPI}")
        set_tests_properties(${testname}_check_output PROPERTIES
            ENVIRONMENT "${CMAKE_CTEST_ENV}" DEPENDS ${testname} SKIP_RETURN_CODE 42)
    endif()

endfunction(add_cli_test)


##### Tests follow below #####



#############################################################################################
### Command line options (basic tests for all program options as listed in --help output) ###
#############################################################################################

# --help

# --version (check if we can run inkscape and the revision is known)
add_cli_test(version       PARAMETERS --version)
add_cli_test(version_known PARAMETERS --version FAIL_FOR_OUTPUT "\\(unknown\\)")

# --system-data-directory / --user-data-directory (unset environment variables to override our override)
# TODO: Can we make these tests more specific without making too many assumptions?
add_cli_test(system-data-directory PARAMETERS --system-data-directory ENVIRONMENT unset PASS_FOR_OUTPUT "inkscape\n$")
add_cli_test(user-data-directory   PARAMETERS --user-data-directory   ENVIRONMENT unset PASS_FOR_OUTPUT "inkscape\n$")

# --pipe

# --pdf-page=PAGE

# --pdf-poppler
add_cli_test(pdf-poppler-mesh-import
                        PARAMETERS --pdf-poppler
                        INPUT_FILENAME pdf-mesh.pdf
                        OUTPUT_FILENAME pdf-mesh_poppler.svg
                        TEST_SCRIPT match_regex.sh pdf-mesh_poppler.svg "<image")
add_cli_test(pdf-internal-mesh-import
                        INPUT_FILENAME pdf-mesh.pdf
                        OUTPUT_FILENAME pdf-mesh_internal.svg
                        TEST_SCRIPT match_regex_fail.sh pdf-mesh_internal.svg "<image")

# --convert-dpi-method=METHOD

# --no-convert-text-baseline-spacing

# --export-filename=FILENAME
## check for https://gitlab.com/inkscape/inkscape/-/issues/1712
install(DIRECTORY DESTINATION ${test.dir})
add_cli_test(export-type-dot-separated PARAMETERS --export-type=svg,png
                         INPUT_FILENAME empty.svg OUTPUT_FILENAME test.dir/empty
                         EXPECTED_FILES test.dir/empty.svg test.dir/empty.png)

# --export-overwrite

# --export-type=TYPE[,TYPE]*

##  test whether we can export all default types in principle (and in one command)
add_cli_test(export-type PARAMETERS --export-type=svg,png,ps,eps,pdf,emf,wmf
                         INPUT_FILENAME empty.svg OUTPUT_FILENAME empty
                         EXPECTED_FILES empty.svg empty.png empty.ps empty.eps empty.pdf empty.emf empty.wmf)
##  test whether this also works if the export types are not lowercase
add_cli_test(export-type-caseinsensitive PARAMETERS --export-type=sVg,Png,PS,eps,Pdf,emf,wmf
                         INPUT_FILENAME empty.svg OUTPUT_FILENAME empty
                         EXPECTED_FILES empty.svg empty.png empty.ps empty.eps empty.pdf empty.emf empty.wmf)

## test whether we produce sane output for the default types
add_cli_test(export-type_svg  PARAMETERS --export-type=svg INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.svg REFERENCE_FILENAME shapes.svg)
add_cli_test(export-type_png  PARAMETERS --export-type=png INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.png REFERENCE_FILENAME shapes_expected.png)
add_cli_test(export-type_ps   PARAMETERS --export-type=ps  INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.ps  REFERENCE_FILENAME shapes_expected.ps)
add_cli_test(export-type_eps  PARAMETERS --export-type=eps INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.eps REFERENCE_FILENAME shapes_expected.eps)
add_cli_test(export-type_pdf  PARAMETERS --export-type=pdf INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.pdf REFERENCE_FILENAME shapes_expected.pdf)
add_cli_test(export-type_emf  PARAMETERS --export-type=emf INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.emf REFERENCE_FILENAME shapes_expected.emf)
add_cli_test(export-type_wmf  PARAMETERS --export-type=wmf INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.wmf REFERENCE_FILENAME shapes_expected.wmf)
# XAML is not supported by ImageMagick's convert, so simply compare binary
add_cli_test(export-type_xaml PARAMETERS --export-type=xaml INPUT_FILENAME shapes.svg OUTPUT_FILENAME shapes.xaml
                              TEST_SCRIPT compare.sh shapes.xaml "${CMAKE_CURRENT_SOURCE_DIR}/testcases/shapes_expected.xaml")

# --export-area-page
add_cli_test(export-area-page_png PARAMETERS --export-area-page --export-type=png INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.png REFERENCE_FILENAME export-area-page_expected.png)
add_cli_test(export-area-page_svg PARAMETERS --export-area-page --export-type=svg INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.svg REFERENCE_FILENAME export-area-page_expected.svg)
add_cli_test(export-area-page_pdf PARAMETERS --export-area-page --export-type=pdf INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.pdf REFERENCE_FILENAME export-area-page_expected.pdf)
add_cli_test(export-area-page_ps  PARAMETERS --export-area-page --export-type=ps  INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.ps  REFERENCE_FILENAME export-area-page_expected.ps)
# EPS: Currently not supported. Feature request: https://gitlab.com/inkscape/inkscape/-/issues/1074
# add_cli_test(export-area-page_eps PARAMETERS --export-area-page --export-type=eps INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.eps REFERENCE_FILENAME export-area-page_expected.eps)
add_cli_test(export-area-page_emf PARAMETERS --export-area-page --export-type=emf INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.emf REFERENCE_FILENAME export-area-page_expected.emf)
add_cli_test(export-area-page_wmf PARAMETERS --export-area-page --export-type=wmf INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page.wmf REFERENCE_FILENAME export-area-page_expected.wmf)

# --export-area-page + --export-id  (+ --export-id-only)
# TODO: PDF/PS/EPS always behave as if --export-id-only was given, see https://gitlab.com/inkscape/inkscape/-/issues/1173
add_cli_test(export-area-page_export-id_png PARAMETERS --export-area-page --export-id=MyStar --export-id-only INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page_export-id.png REFERENCE_FILENAME export-area-page_export-id.png)
add_cli_test(export-area-page_export-id_svg PARAMETERS --export-area-page --export-id=MyStar --export-id-only INPUT_FILENAME areas.svg OUTPUT_FILENAME export-area-page_export-id.svg REFERENCE_FILENAME export-area-page_export-id.svg)

=== src/3rdparty/2geom/src/2geom/CMakeLists.txt ===
# (re-)generate parser file with ragel if it's available
SET(SVG_PARSER_CPP "svg-path-parser.cpp")
SET(SVG_PARSER_RL  "svg-path-parser.rl")
find_program(RAGEL_PROGRAM
   NAMES ragel
   HINTS /usr/bin
         /usr/local/bin
)
if(RAGEL_PROGRAM)
    message(STATUS "Found Ragel in ${RAGEL_PROGRAM}. ${SVG_PARSER_CPP} will be recreated from ${SVG_PARSER_RL}.")
    add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/${SVG_PARSER_CPP}"
                       COMMAND ${RAGEL_PROGRAM} -o "${SVG_PARSER_CPP}" "${SVG_PARSER_RL}"
                       DEPENDS "${SVG_PARSER_RL}"
                       WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                       COMMENT "Generating ${SVG_PARSER_CPP} with ragel")
else()
    message(STATUS "Ragel NOT found. Using stale ${SVG_PARSER_CPP}.")
endif()


add_library(2geom ${LIB_TYPE}
    # sources
    affine.cpp

    basic-intersection.cpp
    bezier.cpp
    bezier-clipping.cpp
    bezier-curve.cpp
    bezier-utils.cpp

    cairo-path-sink.cpp
    circle.cpp
    concepts.cpp
    conicsec.cpp
    conic_section_clipper_impl.cpp
    convex-hull.cpp
    coord.cpp
    crossing.cpp
    curve.cpp

    d2-sbasis.cpp

    ellipse.cpp
    elliptical-arc.cpp
    elliptical-arc-from-sbasis.cpp

    geom.cpp

    intersection-graph.cpp

    line.cpp

    nearest-time.cpp

    numeric/matrix.cpp

    parallelogram.cpp
    parting-point.cpp
    path-extrema.cpp
    path-intersection.cpp
    path-sink.cpp
    path.cpp
    pathvector.cpp
    piecewise.cpp
    point.cpp
    polynomial.cpp

    rect.cpp
    recursive-bezier-intersection.cpp

    sbasis-2d.cpp
    sbasis-geometric.cpp
    sbasis-math.cpp
    sbasis-poly.cpp
    sbasis-roots.cpp
    sbasis-to-bezier.cpp
    sbasis.cpp
    self-intersect.cpp
    solve-bezier.cpp
    solve-bezier-one-d.cpp
    solve-bezier-parametric.cpp
    svg-path-parser.cpp
    svg-path-writer.cpp
    sweep-bounds.cpp

    transforms.cpp

    utils.cpp

    # headers (for IDE support only)
    # private:
    planar-graph.h

    # public:
    ${2GEOM_INCLUDE_DIR}/2geom/affine.h
    ${2GEOM_INCLUDE_DIR}/2geom/angle.h

    ${2GEOM_INCLUDE_DIR}/2geom/basic-intersection.h
    ${2GEOM_INCLUDE_DIR}/2geom/bezier.h
    ${2GEOM_INCLUDE_DIR}/2geom/bezier-curve.h
    ${2GEOM_INCLUDE_DIR}/2geom/bezier-to-sbasis.h
    ${2GEOM_INCLUDE_DIR}/2geom/bezier-utils.h

    ${2GEOM_INCLUDE_DIR}/2geom/cairo-path-sink.h
    ${2GEOM_INCLUDE_DIR}/2geom/choose.h
    ${2GEOM_INCLUDE_DIR}/2geom/circle.h
    ${2GEOM_INCLUDE_DIR}/2geom/concepts.h
    ${2GEOM_INCLUDE_DIR}/2geom/conicsec.h
    ${2GEOM_INCLUDE_DIR}/2geom/conic_section_clipper.h
    ${2GEOM_INCLUDE_DIR}/2geom/conic_section_clipper_cr.h
    ${2GEOM_INCLUDE_DIR}/2geom/conic_section_clipper_impl.h
    ${2GEOM_INCLUDE_DIR}/2geom/convex-hull.h
    ${2GEOM_INCLUDE_DIR}/2geom/coord.h
    ${2GEOM_INCLUDE_DIR}/2geom/crossing.h
    ${2GEOM_INCLUDE_DIR}/2geom/curve.h
    ${2GEOM_INCLUDE_DIR}/2geom/curves.h

    ${2GEOM_INCLUDE_DIR}/2geom/d2.h

    ${2GEOM_INCLUDE_DIR}/2geom/ellipse.h
    ${2GEOM_INCLUDE_DIR}/2geom/elliptical-arc.h
    ${2GEOM_INCLUDE_DIR}/2geom/exception.h

    ${2GEOM_INCLUDE_DIR}/2geom/forward.h

    ${2GEOM_INCLUDE_DIR}/2geom/geom.h

    ${2GEOM_INCLUDE_DIR}/2geom/intersection.h
    ${2GEOM_INCLUDE_DIR}/2geom/intersection-graph.h

    ${2GEOM_INCLUDE_DIR}/2geom/line.h
    ${2GEOM_INCLUDE_DIR}/2geom/linear.h

    ${2GEOM_INCLUDE_DIR}/2geom/math-utils.h

    ${2GEOM_INCLUDE_DIR}/2geom/nearest-time.h

    ${2GEOM_INCLUDE_DIR}/2geom/ord.h

    ${2GEOM_INCLUDE_DIR}/2geom/parallelogram.h
    ${2GEOM_INCLUDE_DIR}/2geom/path-intersection.h
    ${2GEOM_INCLUDE_DIR}/2geom/path-sink.h
    ${2GEOM_INCLUDE_DIR}/2geom/path.h
    ${2GEOM_INCLUDE_DIR}/2geom/pathvector.h
    ${2GEOM_INCLUDE_DIR}/2geom/piecewise.h
    ${2GEOM_INCLUDE_DIR}/2geom/point.h
    ${2GEOM_INCLUDE_DIR}/2geom/polynomial.h

    ${2GEOM_INCLUDE_DIR}/2geom/ray.h
    ${2GEOM_INCLUDE_DIR}/2geom/rect.h

    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-2d.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-curve.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-geometric.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-math.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-poly.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis-to-bezier.h
    ${2GEOM_INCLUDE_DIR}/2geom/sbasis.h
    ${2GEOM_INCLUDE_DIR}/2geom/solver.h
    ${2GEOM_INCLUDE_DIR}/2geom/svg-path-parser.h
    ${2GEOM_INCLUDE_DIR}/2geom/svg-path-writer.h
    ${2GEOM_INCLUDE_DIR}/2geom/sweeper.h
    ${2GEOM_INCLUDE_DIR}/2geom/sweep-bounds.h

    ${2GEOM_INCLUDE_DIR}/2geom/transforms.h

    ${2GEOM_INCLUDE_DIR}/2geom/utils.h
)

# make lib for 2geom
target_include_directories(2geom
    PUBLIC
        ${GLIB_INCLUDE_DIRS}
        ${GSL_INCLUDE_DIRS}
        ${CAIRO_INCLUDE_DIRS}
        ${DoubleConversion_INCLUDE_DIRS}
        $<BUILD_INTERFACE:${2GEOM_INCLUDE_DIR}>
        $<BUILD_INTERFACE:${2GEOM_INCLUDE_DIR}/2geom>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/2geom-${2GEOM_VERSION}>
    )

target_link_libraries(2geom
    PUBLIC
        ${GLIB_LIBRARIES}
        ${GSL_LIBRARIES}
        ${CAIRO_LIBRARIES}
        ${DoubleConversion_LIBRARIES}
    )

set_target_properties(2geom PROPERTIES SOVERSION "${2GEOM_ABI_VERSION}")

install(TARGETS 2geom
    EXPORT 2geom_targets
    RUNTIME
      DESTINATION ${CMAKE_INSTALL_BINDIR}
      COMPONENT "lib2geom${2GEOM_VERSION}"
    LIBRARY
      DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT "lib2geom${2GEOM_VERSION}"
      NAMELINK_COMPONENT "lib2geom_dev"
    ARCHIVE
      DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT "lib2geom${2GEOM_VERSION}"
)

add_library(2Geom::2geom ALIAS 2geom)

=== src/3rdparty/2geom/src/toys/CMakeLists.txt ===
SET(2GEOM_TOY-FRAMEWORK-2_SRC
toy-framework-2.cpp
${2GEOM_INCLUDE_DIR}/toys/toy-framework-2.h
path-cairo.cpp
${2GEOM_INCLUDE_DIR}/toys/path-cairo.h
)
SET(2GEOM_LPE_TOY_FRAMEWORK_SRC
${2GEOM_TOY-FRAMEWORK-2_SRC}
lpe-framework.cpp
${2GEOM_INCLUDE_DIR}/toys/lpe-framework.h
)

SET(2GEOM_TOYS-2_SRC
2dsb2d
aa
arc-bez
arc-length-param
auto-cross
boolops-toy
bound-path
bounds-test
box3d
center-warp
circle-fitting
circle-intersect
circle-line-intersect
circle-tangent-fitting
collinear-normal
conic-3
conic-4
conic-5
conic-6
conic-section-toy
convole
curvature-curve
curvature-test
curve-curve-distance
curve-curve-nearest-time
curve-intersection-by-bezier-clipping
curve-intersection-by-implicitization
cylinder3d
d2sbasis-fitting
d2sbasis-fitting-with-np
draw-toy
ellipse-area-minimizer
ellipse-bezier-intersect-toy
ellipse-fitting
ellipse-intersect-toy
ellipse-line-intersect-toy
elliptiarc-3point-center-fitting
elliptiarc-curve-fitting
elliptical-arc-toy
evolute
filet-minion
find-derivative
gear
#hatches
implicit-toy
ineaa
inner-product-clip
intersect-data
inverse-test
kinematic_templates
levelsets-test
line-toy
load-svgd
match-curve
mesh-grad
metro
minsb2d-solver
#normal-bundle
offset-toy
pair-intersect
paptest
parametrics
parser
path-along-path
path-effects
pencil
pencil-2
plane3d
point-curve-nearest-time
portion-test
precise-flat
pw-compose-test
pw-funcs
pw-toy
rdm-area
rect_01
rect_02
rect_03
rect-toy
root-finder-comparer
#rtree-toy
sanitize
#sb1d
sb2d
sb2d-solver
sbasisdim
sbasis-fitting
sb-math-test
sb-of-interval
sb-of-sb
sb-to-bez
sb-zeros
scribble
self-intersect
sketch-fitter
smash-intersector
squiggles
sweep
sweeper-toy
# these ones have only had a trivial rewrite to toy-2
#uncross
winding-test
worms
)

SET(2GEOM_LPE_TOYS_SRC
lpe-test
)

OPTION(2GEOM_TOYS_LPE
  "Build Inkscape Live Path Effect (LPE) Toy files"
  ON)
IF(2GEOM_TOYS_LPE)
    # make lib for lpetoy
    add_library(lpetoy ${LIB_TYPE} ${2GEOM_LPE_TOY_FRAMEWORK_SRC})
    target_include_directories(lpetoy PUBLIC ${GTK3_INCLUDE_DIRS})
    target_link_libraries(lpetoy 2Geom::2geom ${GTK3_LIBRARIES})
    if(NOT WIN32 AND NOT APPLE)
    	target_link_libraries(lpetoy -lrt)
    endif()

    FOREACH(source ${2GEOM_LPE_TOYS_SRC})
        add_executable(${source} ${source}.cpp)
        target_link_libraries(${source} lpetoy 2Geom::2geom)
    ENDFOREACH(source)

ENDIF(2GEOM_TOYS_LPE)

OPTION(2GEOM_TOYS
  "Build the projects Toy files"
  ON)
IF(2GEOM_TOYS)
    # make lib for toy
    ADD_LIBRARY(toy-2 ${LIB_TYPE} ${2GEOM_TOY-FRAMEWORK-2_SRC})
    target_include_directories(toy-2 PUBLIC ${GTK3_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(toy-2 2Geom::2geom ${GTK3_LIBRARIES})
    if(NOT WIN32 AND NOT APPLE)
    	target_link_libraries(toy-2 -lrt)
    endif()

    FOREACH(source ${2GEOM_TOYS-2_SRC})
        IF(${source} STREQUAL aa)
            ADD_EXECUTABLE(${source} EXCLUDE_FROM_ALL ${source}.cpp)
            TARGET_LINK_LIBRARIES(${source} affa)
        ELSEIF(${source} STREQUAL ineaa)
            ADD_EXECUTABLE(${source} EXCLUDE_FROM_ALL ${source}.cpp)
            TARGET_LINK_LIBRARIES(${source} affa)
        ELSEIF(${source} STREQUAL implicit-toy)
            ADD_EXECUTABLE(${source} EXCLUDE_FROM_ALL ${source}.cpp)
            TARGET_LINK_LIBRARIES(${source} affa)
		ELSEIF(${source} STREQUAL boolops-cgal)
			
        ELSE(${source} STREQUAL aa)
            ADD_EXECUTABLE(${source} ${source}.cpp)
        ENDIF(${source} STREQUAL aa)
        TARGET_LINK_LIBRARIES(${source} toy-2  2Geom::2geom ${GTK3_LIBRARIES} )
    ENDFOREACH(source)
ENDIF(2GEOM_TOYS)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Ray Donnelly <mingw.android@gmail.com>
# Contributor: Naveen M K <naveen521kk@gmail.com>

_realname=inkscape
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.3.2
pkgrel=6
pkgdesc="Vector graphics editor using the SVG file format (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://inkscape.org/"
msys2_repository_url="https://gitlab.com/inkscape/inkscape"
msys2_references=(
  "cpe: cpe:/a:inkscape:inkscape"
)
license=("spdx:GPL-2.0-or-later")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools")
depends=("${MINGW_PACKAGE_PREFIX}-aspell"
         "${MINGW_PACKAGE_PREFIX}-atkmm"
         "${MINGW_PACKAGE_PREFIX}-boost"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-cairomm"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-gc"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gdk-pixbuf2"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-ghostscript"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-graphicsmagick"
         "${MINGW_PACKAGE_PREFIX}-gsl"
         "${MINGW_PACKAGE_PREFIX}-gtkmm3"
         "${MINGW_PACKAGE_PREFIX}-gtkspell3"
         "${MINGW_PACKAGE_PREFIX}-gtk-update-icon-cache"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-hicolor-icon-theme"
         "${MINGW_PACKAGE_PREFIX}-lcms2"
         "${MINGW_PACKAGE_PREFIX}-lib2geom"
         "${MINGW_PACKAGE_PREFIX}-libcdr"
         "${MINGW_PACKAGE_PREFIX}-libepoxy"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-librevenge"
         "${MINGW_PACKAGE_PREFIX}-libsigc++"
         "${MINGW_PACKAGE_PREFIX}-libsoup"
         "${MINGW_PACKAGE_PREFIX}-libvisio"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libxslt"
         "${MINGW_PACKAGE_PREFIX}-libwpg"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-pangomm"
         "${MINGW_PACKAGE_PREFIX}-poppler"
         "${MINGW_PACKAGE_PREFIX}-potrace"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-readline"
         "${MINGW_PACKAGE_PREFIX}-scour"
         "${MINGW_PACKAGE_PREFIX}-zlib")
optdepends=(#"${MINGW_PACKAGE_PREFIX}-pstoedit: latex formulas"
            "${MINGW_PACKAGE_PREFIX}-texlive-scheme-medium: latex formulas"
            "${MINGW_PACKAGE_PREFIX}-python-numpy: some extensions"
            "${MINGW_PACKAGE_PREFIX}-python-lxml: some extensions and filters"
            #"${MINGW_PACKAGE_PREFIX}-scour: optimized SVG output"
            #"${MINGW_PACKAGE_PREFIX}-uniconvertor: reading/writing to some proprietary formats"
            )
source=("https://media.inkscape.org/dl/resources/file/${_realname}-${pkgver}.tar.xz"
        inkscape-1.0.1-unbundle.patch
        inkscape-1.0.1-install-layout.patch
        003-include-missing-header.patch::https://gitlab.com/inkscape/inkscape/-/commit/694d8ae4.patch
        004-up-c++-to-c++20.patch::https://gitlab.com/inkscape/inkscape/-/commit/1798e9c1.patch
        005-fix-build-with-poppler-24.03.patch::https://gitlab.com/inkscape/inkscape/-/commit/f7e94457.patch
        006-fix-build-with-poppler-24.05.patch::https://gitlab.com/inkscape/inkscape/-/commit/96ca7a6c.patch)
sha256sums=('dbd1844dc443fe5e10d3e9a887144e5fb7223852fff191cfb5ef7adeab0e086b'
            '92387251c1740f1a57cde9e587cc673ef1600813617bd2c9db65598c324a24d4'
            '131b2e1190637df0554ef1ee8cf46440689584375c117d057ab47d5871c58128'
            'edc55ad0771b604c63737524fc5928a35334db04d6479e395801635d5f6dfc1f'
            '658f9d5c63af94e5e85d649e1fd9d45d6639916702154197dfa25afc1a515145'
            '8b85c64eb65d248c1b8cf5b670314dad67be63f3b6e8235e0473e73f53255bed'
            'a83bb96779db1d3ed475d32e67c4ef1a5b56675c7cf323a04c5b28f938a0ac4e')
noextract=("${_realname}-${pkgver}.tar.xz")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  # Symlinks only in packaging/macos and src/3rdparty/cairo folders
  tar -xf ${_realname}-${pkgver}.tar.xz || true

  mv "${srcdir}"/${_realname}-${pkgver}_* "${srcdir}"/${_realname}-${pkgver}
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    inkscape-1.0.1-unbundle.patch \
    inkscape-1.0.1-install-layout.patch \
    003-include-missing-header.patch \
    004-up-c++-to-c++20.patch \
    005-fix-build-with-poppler-24.03.patch \
    006-fix-build-with-poppler-24.05.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  local -a extra_config
  if check_option "debug" "y"; then
    extra_config+=(-DCMAKE_BUILD_TYPE=Debug)
  else
    extra_config+=(-DCMAKE_BUILD_TYPE=Release)
  fi

  CFLAGS+=" -Wno-implicit-function-declaration" \
  MSYS=winsymlinks:native \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DBUILD_TESTING=OFF \
    -DCMAKE_AR=${MINGW_PREFIX}/bin/ar \
    -DWITH_IMAGE_MAGICK=OFF \
    -DWITH_INTERNAL_CAIRO=OFF \
    -DWITH_INTERNAL_2GEOM=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd ${srcdir}/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
